
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Feature_flagsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const feature_flags = await db.feature_flags.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        enabled: data.enabled
        ||
        false
        
            ,
            
        target_scope: data.target_scope
        ||
        null
            ,
            
        rollout_percentage: data.rollout_percentage
        ||
        null
            ,
            
        enabled_at: data.enabled_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await feature_flags.setTenant( data.tenant || null, {
            transaction,
        });
        
        await feature_flags.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return feature_flags;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const feature_flagsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                enabled: item.enabled
            ||
            false
        
            ,
            
                target_scope: item.target_scope
            ||
            null
            ,
            
                rollout_percentage: item.rollout_percentage
            ||
            null
            ,
            
                enabled_at: item.enabled_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const feature_flags = await db.feature_flags.bulkCreate(feature_flagsData, { transaction });

        // For each item created, replace relation files
        

        return feature_flags;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const feature_flags = await db.feature_flags.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.enabled !== undefined) updatePayload.enabled = data.enabled;
        
        
        if (data.target_scope !== undefined) updatePayload.target_scope = data.target_scope;
        
        
        if (data.rollout_percentage !== undefined) updatePayload.rollout_percentage = data.rollout_percentage;
        
        
        if (data.enabled_at !== undefined) updatePayload.enabled_at = data.enabled_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await feature_flags.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await feature_flags.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await feature_flags.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return feature_flags;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const feature_flags = await db.feature_flags.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of feature_flags) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of feature_flags) {
                await record.destroy({transaction});
            }
        });


        return feature_flags;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const feature_flags = await db.feature_flags.findByPk(id, options);

        await feature_flags.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await feature_flags.destroy({
            transaction
        });

        return feature_flags;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const feature_flags = await db.feature_flags.findOne(
            { where },
            { transaction },
        );

        if (!feature_flags) {
            return feature_flags;
        }

        const output = feature_flags.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await feature_flags.getTenant({
            transaction
        });
        
        
        output.organizations = await feature_flags.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'feature_flags',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'feature_flags',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.rollout_percentageRange) {
                const [start, end] = filter.rollout_percentageRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rollout_percentage: {
                    ...where.rollout_percentage,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rollout_percentage: {
                    ...where.rollout_percentage,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.enabled_atRange) {
                const [start, end] = filter.enabled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    enabled_at: {
                    ...where.enabled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    enabled_at: {
                    ...where.enabled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.enabled) {
                where = {
                    ...where,
                enabled: filter.enabled,
            };
            }
            
            if (filter.target_scope) {
                where = {
                    ...where,
                target_scope: filter.target_scope,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.feature_flags.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'feature_flags',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.feature_flags.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

